Package com.io7m.coffeepick.runtime.parser.spi

# Class ParseError.Builder

java.lang.Object
com.io7m.coffeepick.runtime.parser.spi.ParseError.Builder

Enclosing class:
  ParseError

    public static final class ParseError.Builder
    extends java.lang.Object

Builds instances of type `ParseError`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `ParseError` | `build()` | Builds a new `ParseError`.
  `ParseError.Builder` | `from​(ParseErrorType instance)` | Fill a builder with attribute values from the provided `ParseErrorType` instance.
  `ParseError.Builder` | `setException​(java.lang.Exception exception)` | Initializes the optional value `exception` to exception.
  `ParseError.Builder` | `setException​(java.util.Optional<? extends java.lang.Exception> exception)` | Initializes the optional value `exception` to exception.
  `ParseError.Builder` | `setLexical​(com.io7m.jlexing.core.LexicalPosition<java.net.URI> lexical)` | Initializes the value for the `lexical` attribute.
  `ParseError.Builder` | `setMessage​(java.lang.String message)` | Initializes the value for the `message` attribute.
  `ParseError.Builder` | `setSeverity​(ParseErrorType.Severity severity)` | Initializes the value for the `severity` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final ParseError.Builder from​(ParseErrorType instance)
    Fill a builder with attribute values from the provided `ParseErrorType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setLexical

    public final ParseError.Builder setLexical​(com.io7m.jlexing.core.LexicalPosition<java.net.URI> lexical)
    Initializes the value for the `lexical` attribute.
    Parameters:
      `lexical` - The value for lexical
    Returns:
      `this` builder for use in a chained invocation

  - ### setSeverity

    public final ParseError.Builder setSeverity​(ParseErrorType.Severity severity)
    Initializes the value for the `severity` attribute.
    Parameters:
      `severity` - The value for severity
    Returns:
      `this` builder for use in a chained invocation

  - ### setMessage

    public final ParseError.Builder setMessage​(java.lang.String message)
    Initializes the value for the `message` attribute.
    Parameters:
      `message` - The value for message
    Returns:
      `this` builder for use in a chained invocation

  - ### setException

    public final ParseError.Builder setException​(java.lang.Exception exception)
    Initializes the optional value `exception` to exception.
    Parameters:
      `exception` - The value for exception
    Returns:
      `this` builder for chained invocation

  - ### setException

    public final ParseError.Builder setException​(java.util.Optional<? extends java.lang.Exception> exception)
    Initializes the optional value `exception` to exception.
    Parameters:
      `exception` - The value for exception
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public ParseError build()
    Builds a new `ParseError`.
    Returns:
      An immutable instance of ParseError
    Throws:
      `java.lang.IllegalStateException` - if any required attributes are missing